%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% CRAY-ASM.SL -   CRAY specific information for LAP-TO-ASM              %
%                                                                       %
% Author:      M. L. Griss                                              %
%              Computer Science Dept.                                   %
%              University of Utah                                       %
% Date:        1 June 1982                                              %
% Based on M68k-ASM by Maguire, Lowder, Griss, Peterson                 %
%                                                                       %
% Copyright (c) 1987 Konrad Zuse Zentrum Berlin , for modifications     %
% Copyright (c) 1982 Griss, Lowder, Kessler, Benson for CRAY            %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 
% W. Neun ZIB Berlin 20-Oct-88
%    Included SYMGET vector
% W. Neun ZIB Berlin 20-Oct-87
%    Changed Header of Assembler main object for UNICOS
% W. Neun ZIB Berlin 20-May-86
%    Changed to support PSL 3.4
%    allocated some more Fluid-Variables in B-Registers
%    allocate symcnt if *counting for counting PSL
%    added dynamic allocation of heap bps and stack
%    moved definition of frame-tregs to cmacros
%    moved definition of special registernames to cmacros
% D. Dawson 17-July-85
%   Changed "ENTRY COSPSL" to "START COSPSL".  CAL likes that better.
% D. Dawson 12-July-85
%   Removed tab characters from emitted CAL code.
%   Changed lower case to upper case for CRAY CAL output.
%   Changed CRAYSymbolP so it won't allow lower case symbols.
%   Changed the string "CTSS" to "COS" everywhere.
% 13-May-85 - Kessler - Added asmopenparen* and asmcloseparen* values.
% 9-May-85 - Kessler
%  - Changed asmoutlap to compute the number of links in code.
%  - Added Declaration of Frame Tregs.
%  - Changed entry so it prints using crayprintlabel.
%  - Changed asmoutlap so it checks prog bind and lambind.
% 9-May-85 - Kessler - Made T into a T register (T21).  Made the init
%  in codefileheader, and made its name in registernames.
% 8-May-85 - Kessler - Made Stack and Heap maxies T registers.
% 5-Feb-85 15:45:50, Edit by ANDERSON
%  Removed the 0 in the ERR    0        return in CodeFileHeader
%  so that the code will run on the XMP
% 25-Jun-84 13:49:08, Edit by GALWAY
%   Inserted definition of DoubleFloatFormat* so that floating point
%   constants will work in ASMOut stuff.  SEE COMMENTS BELOW--this may not
%   work when run on the DEC-20.
% <PSL.COMP.CRAY>CRAY-ASM.RED.67,  8-Aug-83 10:24:08, Edit by KESSLER
%  Change Printlabel to check for Multiple labels.
%=============================================================================
%   11/11/82 - rrk- Benson modified so it only puts out one space at the front
%              of the line.  This is not acceptable, so ASMOUTLAP1 has been
%              modified so it will put out whatever is in the variable
%              InstructionLeadingSpaces* at the front of the line.
%=============================================================================
 
(FLUID '(CODEFILENAMEFORMAT*
         DATAFILENAMEFORMAT*
         DOUBLEFLOATFORMAT*
%        GLOBALDATAFILENAME*
         COMMENTFORMAT*
         LABELFORMAT*
         SPECIALLABELFORMAT*
         LOCALLABELS*
%-----------------------------------------------------------------------
%-- rrk 11/11/82 - The spaces before each instruction on a line.
         InstructionLeadingSpaces*
%-----------------------------------------------------------------------
         EXTERNALDECLARATIONFORMAT*
         EXPORTEDDECLARATIONFORMAT*
         FULLWORDFORMAT*
         HALFWORDFORMAT*
         RESERVEDATABLOCKFORMAT*
         RESERVEZEROBLOCKFORMAT*
         DEFINEDFUNCTIONCELLFORMAT*
         UNDEFINEDFUNCTIONCELLINSTRUCTIONS*
         MAINENTRYPOINTNAME*
         CODEOUT*
         DATAOUT*
         *counting
         *LOWER
         *DECLAREBEFOREUSE
         ASMOPENPAREN*
         ASMCLOSEPAREN*
         NUMERICREGISTERNAMES*
         FOREIGNEXTERNLIST*
         DATAPROCSTATE*))
 
 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% This assembler produces two files: a code file and a data file. Both  %
% of these files are assembled to reside in the CRAY dataspace          %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                  FORMATS                                              %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 
(SETQ CODEFILENAMEFORMAT* "%w")
           % CAL doesnt like .xxx
(SETQ DATAFILENAMEFORMAT* "%wD")
 
 
% USE %e in DoubleFloatFormat* to be "safe", in case the argument passed
% is something that evaluates to a float, rather than a float itself.  ALSO
% NOTE that this will only work if the cross compiler is running on a
% machine that prints floats in a format that the CRAY will accept.  This
% appears to be true on the Unix cross compiler, but may not be true on the
% DEC-20.  (Consider the case where the float is 0.1 )
 
(SETQ DOUBLEFLOATFORMAT* "     CON %e%n")
 
%-----------------------------------------------------------------------
%-- rrk 11/11/82 - The spaces before the instruction is printed.
(SETQ INSTRUCTIONLEADINGSPACES* "     ")
%-----------------------------------------------------------------------
 
(SETQ SPECIALLABELFORMAT* " = *%n%w ")  % Labels are in the first column
(SETQ LABELFORMAT* "%w ")  % Labels are in the first column
% Maybe need BITW 64
 
% Define cal parens
(SETQ ASMOPENPAREN* "")
(SETQ AsmCloseParen* "")
 
%  Redefine DataPrintLabel, so we can fix the problem with data labels
%   occuring on the wrong line.
(DE DATAPRINTLABEL (LAB)
  (DATAPRINTF "%w  =  W.*%n" LAB))
 
 
(SETQ COMMENTFORMAT* "* %p%n")        % Comments begin with an asterisk
                                       % will group alphabetically
 
(SETQ EXPORTEDDECLARATIONFORMAT* "     ENTRY  %w%n")
 
(SETQ EXTERNALDECLARATIONFORMAT* "     EXT %w%n")
 
(SETQ *DECLAREBEFOREUSE T)            % Force Early ENTRY?
 
(SETQ FULLWORDFORMAT* "     CON %e%n") % FullWord expects %e for parameter
%/HalfWordFormat* :="     CON %e%n"$   % Will EVAL formatter
 
(SETQ RESERVEDATABLOCKFORMAT* "     BSS %e%n")  %/ Bytes, so divide by 8?
(SETQ RESERVEZEROBLOCKFORMAT* "%w BSSZ %e%n")
 
 
(PUT 'MKITEM 'ASMEXPRESSIONFORMAT "%e*TAGSHIFT+%e") % MkItem(Tag, Inf)
%/ need to define Tagshift
 
(SETQ DEFINEDFUNCTIONCELLFORMAT* "     BITW 64%n     J P.%w%n")
 
             % Note that called in LAP-TO-ASM in InitSymfnc1 via the
             % DefinedFunctionCell procedure
             % Extern Decl checked/output now by DateDeclare External
 
 
(setq undefinedfunctioncellinstructions*
      '((bitw 64) (j (plus2 (parcel symfnc) (times2 4
                            (idloc undefinedfunction))))))
 
(SETQ LAMBDAFUNCTIONCELLINSTRUCTIONS*
      '((BITW 64) (*JCALL COMPILEDCALLINGINTERPRETED)) )
 
 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%            LISTS and CONSTANT DEFINITIONS                             %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 
(put 'symfnc 'symbol 'symfnc) (put 'symval 'symbol 'symval)
(put 'symget 'symbol 'symggg) (put 'symggg 'symbol 'symggg)
(put 'symprp 'symbol 'symprp) (put 'symnam 'symbol 'symnam)
 
(SETQ MAINENTRYPOINTNAME* 'COSMAIN)  % chose a simple default
                                       % main procedure name
 
(SETQ NUMERICREGISTERNAMES* '[ "S0" "S1" "S2" "S3" "S4" "S5"])
  % Keep some Si free
 
%/ASMOpenParen* := '($    %/ No parens
%/ASMCloseParen* := ')$
 
%DefList('((LAnd &)     %/ none legal in CAL
%        (LOr  )
%        (LSH <<)), 'BinaryASMOp)$
 
(DEFLIST '((B00 "B00") (B01 "B01") (B02 "B02") (B03 "B03") (B04 "B04")
           (B05 "B05") (B06 "B06") (B07 "B07") (B10 "B10") (B11 "B11")
           (B12 "B12") (B13 "B13") (B14 "B14") (B15 "B15") (B16 "B16")
           (B17 "B17") (B20 "B20") (B21 "B21") (B22 "B22") (B23 "B23")
           (B24 "B24") (B25 "B25") (B26 "B26") (B27 "B27") (B30 "B30")
           (B31 "B31") (B32 "B32") (B33 "B33") (B34 "B34") (B35 "B35")
           (B36 "B36") (B37 "B37") (B40 "B40") (B41 "B41") (B42 "B42")
           (B43 "B43") (B44 "B44") (B45 "B45") (B46 "B46") (B47 "B47")
           (B50 "B50") (B51 "B51") (B52 "B52") (B53 "B53") (B54 "B54")
           (B55 "B55") (B56 "B56") (B57 "B57") (B60 "B60") (B61 "B61")
           (B62 "B62") (B63 "B63") (B64 "B64") (B65 "B65") (B66 "B66")
           (B67 "B67") (B70 "B70") (B71 "B71") (B72 "B72") (B73 "B73")
           (B74 "B74") (B75 "B75") (B76 "B76") (B77 "B77"))
         'REGISTERNAME)
 
(DEFLIST '((T00 "T00") (T01 "T01") (T02 "T02") (T03 "T03") (T04 "T04")
           (T05 "T05") (T06 "T06") (T07 "T07") (T10 "T10") (T11 "T11")
           (T12 "T12") (T13 "T13") (T14 "T14") (T15 "T15") (T16 "T16")
           (T17 "T17") (T20 "T20") (T21 "T21") (T22 "T22") (T23 "T23")
           (T24 "T24") (T25 "T25") (T26 "T26") (T27 "T27") (T30 "T30")
           (T31 "T31") (T32 "T32") (T33 "T33") (T34 "T34") (T35 "T35")
           (T36 "T36") (T37 "T37") (T40 "T40") (T41 "T41") (T42 "T42")
           (T43 "T43") (T44 "T44") (T45 "T45") (T46 "T46") (T47 "T47")
           (T50 "T50") (T51 "T51") (T52 "T52") (T53 "T53") (T54 "T54")
           (T55 "T55") (T56 "T56") (T57 "T57") (T60 "T60") (T61 "T61")
           (T62 "T62") (T63 "T63") (T64 "T64") (T65 "T65") (T66 "T66")
           (T67 "T67") (T70 "T70") (T71 "T71") (T72 "T72") (T73 "T73")
           (T74 "T74") (T75 "T75") (T76 "T76") (T77 "T77"))
         'REGISTERNAME)
 
 
(DEFLIST '((A0 "A0") (A1 "A1") (A2 "A2") (A3 "A3") (A4 "A4") (A5 "A5")
           (A6 "A6") (A7 "A7"))
         'REGISTERNAME)
 
 
(DEFLIST '((S0 "S0") (S1 "S1") (S2 "S2") (S3 "S3") (S4 "S4") (S5 "S5")
           (S6 "S6") (S7 "S7"))
         'REGISTERNAME)
 
(DEFLIST '((V0 "V0") (V1 "V1") (V2 "V2") (V3 "V3") (V4 "V4") (V5 "V5")
           (V6 "V6") (V7 "V7") (VL "VL") (VM "VM"))
         'REGISTERNAME)
 
(SETQ DATAPROCSTATE* 'DATA)
 
% This patch is until init files can be read
 
%(COPYD 'SAVEUNCOMPILEDEXPRESSION 'SAVEFORCOMPILATION)
 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%            CODE HEADERS AND TRAILERS                                  %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
(DE CODEFILEHEADER NIL        % Pure Code Segment
 (COND (*MAIN
        (PROG (init-size)                   % Must be loaded to 200(8)
         (CodePrintF "     IDENT KAPUTT %n") %I HOPE NOBODY ELSE WILL
         (CodePrintF "     ENTRY CARNIL %n") % USE THIS NAME
         (CodePrintF "CARNIL  BSSZ  2 %n")     % Room for (Car nil)
       %                                       % and      (Cdr nil)
         (CodePrintF "     EXT   BLOWNUQ %n")
         (CodePrintF "     ENTRY BLOWNUP %n") % USE THIS NAME
         (CodePrintF "BLOWNUP = * %n") % for
         (CodePrintF "     J     BLOWNUQ%n")  %STACKOVERFLOW !
         (CodePrintF "     END %n")
%
% Analysis is done in LISP-function BLOWNUQ
%
         (CodePrintF "     IDENT %w%n" MODNAME*)
         (CodePrintF "     START COSPSL%n")
         (SETQ DATAPROCSTATE* 'DATA)
         (CodePrintF "* this is the start of execution%n")
 
  %/ Issue EXT early
         (CODEDECLAREEXTERNAL 'SYMVAL)
         (CODEDECLAREEXTERNAL 'Symggg)
         (CODEDECLAREEXTERNAL 'SYMFNC)
         (CODEDECLAREEXTERNAL 'SYMPRP)
         (CODEDECLAREEXTERNAL 'SYMNAM)
         (CODEDECLAREEXTERNAL 'CARNIL)
         (CodePrintF "COSPSL   = * %n")
         (CodePrintF "TAGSHIFT = X'800000000000000%n")
         (CodePrintF "     LOAD S1,SYMVAL+128         Initialize NIL Reg %n")
         (CodePrintF "     STORE S1,CARNIL %n")                          %n")
         (CodePrintF "     STORE S1,CARNIL+1 %n")% Car and cdr of nil    %n")
         (CodePrintF "     MOVE T00,S1%n")
         (CodePrintF "     LOAD S1,SYMVAL+116         Initialize T Reg%n")
         (CodePrintF "     MOVE T21,S1%n")
         (CodePrintF "* Load A and B's with Stack bases%n")
       (setq init-size (plus (compiler-constant 'initial-stacksize)
                             (compiler-constant 'initial-heapsize)
                             (compiler-constant 'initial-bndstksize)
                             (compiler-constant 'initial-bpssize) 30))
       (if *counting    % allocate symcnt
        (CodePrintf "     S1    %d%n" (plus init-size
                             (compiler-constant 'maxsymbols)))
        (CodePrintf "     S1    %d%n" init-size)
       ) 
        (CodePrintf "     S2    10        Abort on Error%n")
        (CodePrintf "     EXT   INTALLC   does the inital alloc %n")
        (CodePrintf "     R     INTALLC %n")
        (CodePrintf "     A1    64 %n")
        (CodePrintf "     A0    BREGSAVE+64 %n")
        (codeprintf "     BLKSTO A1,B00 %n")
  %
  % saving Bregisters for UNICOS environment
  %
       % 
       % Alloc returns the address of Memory Block in S1
       % It will be passed to COSMAIN as first Parameter
       %    We should have a Stack before we enter Lisp^
       % 
        (CodePrintf "      A4   S1%n")
       % Initial Memory layout:
       %       ***** Block allocated via COS Heap Manager *******
       %       ^
       %       Stack (very small)
       % 
       % When Lisp is active the picture above is changed as follows:
       % First Lisp Memory layout:
       %       ***** Block allocated via COS Heap Manager *******
       %       ^     ^            ^               ^ ^
       %       Lost  Bps          Heap            Stack Bndstk
       % The Heap can be moved in Memory easyly by garbage-collector
       % techniques, Stack can be moved, but Bps is fixed.
       % So, if something sould be enlarged, do a newlen%-callv to
       % COS Heap-Manager and do this the right way^
       %       ***** Block enlarged          via COS Heap Manager *******
       %       ^     ^                         ^              ^ ^
       %       Lost  Bps enlarged              Heap           Stack Bndstk
 
         (CodePrintF "* Load up consts into T or B%n")
         (CodePrintF "     A1   SYMVAL %n")
         (CodePrintF "     B50  A1 %n")      % NEW B-REG USAGE 16-1-86
         (CodePrintF "     A1   SYMFNC %n")
         (CodePrintF "     B51  A1 %n")
         (CodePrintF "     A1   SYMPRP %n")
         (CodePrintF "     B52  A1 %N")
         (CodePrintF "     A1   SYMNAM %n")
         (CodePrintF "     B53  A1 %N")
         (CodePrintF "     A1   SYMGGG %n")
         (CodePrintF "     B41  A1 %N")
         (CodePrintF "     A3   2 %n") % no frame yet
         (CodePrintf "     A1   500 %n")
         (CodePrintf "     A1   A1+A4 %n")  %just any size
         (CodePrintf "     B54  A1 %n")     %for check stackoverflow
%
       (when *counting
         (CodePrintf "     A1   %w %n" init-size)
         (CodePrintf "     A1   A1+A4 %n")
         (Codeprintf "     B66  A1 %n")
       ) 
         (CodePrintF "     R P.%w                  Call Main Routine%n"
                                   MAINENTRYPOINTNAME*)
         (CodePrintF "* now return to OS%n")
         (CodePrintF "     ERR%n")
         (SETQ FOREIGNEXTERNLIST* NIL)
         NIL))
  (T (PROGN (CodePrintF "     IDENT %w%n" MODNAME*)
                      %/ Kludge, since ModuleName set in ASMOUT
            (SETQ DATAPROCSTATE* 'DATA)
            (CODEDECLAREEXTERNAL 'SYMVAL)         %/ Issue EXTERN.D early
            (CODEDECLAREEXTERNAL 'SYMGgg)         %/ Issue EXTERN.D early
            (CODEDECLAREEXTERNAL 'SYMFNC)
            (CODEDECLAREEXTERNAL 'TREGSAVE)
            (CODEDECLAREEXTERNAL 'BREGSAVE)
            (CodePrintF "* this is an Independent Module %n")
            (CodePrintF "TAGSHIFT = X'800000000000000%n")
            (SETQ FOREIGNEXTERNLIST* NIL)
             NIL))))
 
(DE DATAFILEHEADER NIL
  (PROG NIL
        (DATAPRINTF "     IDENT %wD%n" MODNAME*)
        (DATAPRINTF "TAGSHIFT = X'800000000000000%n")))
 
(DE DATAFILETRAILER NIL
  (DATAPRINTF "     END%n"))
 
 
(DE CODEFILETRAILER NIL
  (PROGN (FOREACH FN IN (REVERSE FOREIGNEXTERNLIST*) DO
                  (CodePrintF "     EXT %w%n" FN))
          (CodePrintF "     END%n")))
 
 
(DE CHECKFOREIGNEXTERN (FN)
  (COND ((NOT (MEMQ FN FOREIGNEXTERNLIST*))
         (SETQ FOREIGNEXTERNLIST* (CONS FN FOREIGNEXTERNLIST*)))))
 
(DE CODEBLOCKHEADER NIL  %/ Chuck this?
  NIL)
 
(DE CODEBLOCKTRAILER NIL
  NIL)
 
(DE DATAALIGNFULLWORD NIL
  (DATAPRINTF "     BITW 64%n"))
 
(DE CODEALIGNFULLWORD NIL       %/ Not called yet
  (CodePrintF "     BITW 64%n"))
 
 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                   PRINT PROCEDURES                                    %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 
(DE PRINTSTRING (S)
  (PROG (N N8)
        (COND ((NEQ (SIZE S) -1)
               (PROGN (SETQ N (SIZE S))
                      (FOR (FROM I 0 N 1)
                           (DO (PRINTBYTE8 (REMAINDER I 8) (INDX S I))))
                      (PRINTBYTE8 (REMAINDER (PLUS N 1) 8) 0)
                      (TERPRI)
                      NIL))
              (T (PRIN2T "     VWD 8/0")))))
 
 
(DE PRINTBYTE8 (I X)
  (PROGN (COND ((EQUAL I 0) (PRIN2 "     VWD 8/"))
               (T (PRIN2 ",8/"))) %/ no Blanks
         (PRINTEXPRESSION X)
         (COND ((EQUAL I 7) (TERPRI)))))
 
 
(DE TRUNCATESTRING (S N)
  (COND ((LEQ (SIZE S) N) S)
        (T (SUB S 0 N))))
 
 
(DE PRINTBYTELIST (L)
  (PROG (I)
        (SETQ I 0)
        (FOREACH X IN L DO
                 (PROGN (PRINTBYTE8 (REMAINDER I 8) X)
                        (SETQ I (PLUS I 1))))
        (TERPRI)))
 
 
(DE PRINTBYTE (X)                   %/ Careful, not packed?
  (PROGN (PRIN2 "     VWD 8/")
         (PRINTEXPRESSION X)
         (TERPRI)
         NIL))
 
 
(DE PRINTHALFWORDLIST (L)
  (FOREACH X IN L DO (PRINTHALFWORD X)))
 
 
(DE PRINTHALFWORD (X)
  (PROGN (PRIN2 "     VWD 32/")
         (PRINTEXPRESSION X)
         (PRIN2 $EOL$)))
 
 
(DE PRINTHALFWORDS (X)
  (PROGN (RPLACA PRINTEXPRESSIONFORMPOINTER* X)
         (PRINTF HALFWORDFORMAT* PRINTEXPRESSIONFORM*)))
 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% ASMPseudoOp, handles OPCODE specially, rather than as just
% instruction output form is:
% "tab" <opcode>   "space" <operand> { "comma" <operand> }   "newline"
 
(PUT 'COMMENT 'ASMPSEUDOOP 'PRINTCOMMENT)
 
(PUT 'HALFWORD 'ASMPSEUDOOP 'ASMPSEUDOPRINTHALFWORDS)
 
(DE ASMPSEUDOPRINTHALFWORDS (X)
  (FOREACH Y IN (CDR X) DO (PRINTHALFWORD Y)))
 
 
(DE PRINTOPCODE (X)       % default Opcode Printer
  (PROG NIL
        (PRIN2 X)))
 
(DE SPECIALACTIONFORMAINENTRYPOINT NIL
  (PROGN (CODEALIGNFULLWORD)
         (COND (*DECLAREBEFOREUSE (CODEDECLAREEXPORTED
                                    MAINENTRYPOINTNAME*)))
         (CodePrintLABEL MAINENTRYPOINTNAME*)
         (COND ((NOT *DECLAREBEFOREUSE)
                (CODEDECLAREEXPORTED MAINENTRYPOINTNAME*)))
         NIL))
 
(DE ASMSYMBOLP (X)
  (CRAYSYMBOLP (COND ((IDP X) (ID2STRING X))
                     (T X))))
 
 
(DE CRAYSYMBOLP (X)
%/ do not use @, confuzed with GETMEM, ie as NENAM, not OP...
  (PROG (N C I)
        (SETQ N (SIZE X))
        (COND ((GEQ N 8) (RETURN NIL)))
        (SETQ C (INDX X 0))
        (COND ((NOT (OR (AND (GEQ C (CHAR A)) (LEQ C (CHAR Z)))
                        (EQUAL C (CHAR !%)) (EQUAL C (CHAR $))))
               (RETURN NIL)))
        (SETQ I 1)
   LOOP
        (COND ((GREATERP I N) (RETURN T)))
        (SETQ C (INDX X I))
        (COND ((NOT (OR (AND (GEQ C (CHAR A)) (LEQ C (CHAR Z)))
                        (EQUAL C (CHAR !%)) (EQUAL C (CHAR $))
                        (AND (GEQ C (CHAR 0)) (LEQ C (CHAR 9)))))
               (RETURN NIL)))
        (SETQ I (PLUS I 1))
        (GO LOOP)))
 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% OperandPrintFunctions:
% You have to be careful with the adressing modes on the CRAY regs.
% Only A regs can be indexes, cant touch A0, S0, etc
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 
(DE PRINTNUMERICOPERAND (X)
  (PRIN2 X))
 
 
(DE OPERANDPRINTINDEXED (X)
  (PROG (RG DISP)
        (SETQ X (CDR X))
        (SETQ RG (CAR X))
        (SETQ DISP (CADR X))
%/ Check that AREGP and Number/AddressP
        (PRINTEXPRESSION DISP)
        (PRIN2 ",")
        (PRINTOPERAND RG)))
 
(PUT 'INDEXED 'OPERANDPRINTFUNCTION 'OPERANDPRINTINDEXED)
 
(DE OPERANDPRINTIMMEDIATE (X) % (Immediate x) % for ADDRESS
  (PRINTEXPRESSION (CADR X)))
 
(PUT 'IMMEDIATE 'OPERANDPRINTFUNCTION 'OPERANDPRINTIMMEDIATE)
 
(DE OPERANDPRINTLABELGEN (X)                  % for ADDRESS
  (PRINTEXPRESSION (APPLY (CAR X) (CDR X))))
 
(PUT 'LABELGEN 'OPERANDPRINTFUNCTION 'OPERANDPRINTLABELGEN)
 
(DE OPERANDPRINTPARCEL (X) % (Parcel x) % for J and R
  (PROGN (PRIN2 "P.")
         (PRINTEXPRESSION (CADR X))))
 
(PUT 'PARCEL 'OPERANDPRINTFUNCTION 'OPERANDPRINTPARCEL)
 
(PUT 'PARCEL 'ASMEXPRESSIONFUNCTION 'OPERANDPRINTPARCEL)
 
(DE OPERANDPRINTICONST (X)
  (PRINTEXPRESSION (CADR X)))
 
(PUT 'ICONST 'OPERANDPRINTFUNCTION 'OPERANDPRINTICONST)
 
(DE OPERANDPRINTFOREIGNENTRY (X)  % (ForeignEntry FcnName)
  (PROG NIL
        (PRIN2 (CADR X))
        (CHECKFOREIGNEXTERN (CADR X))))
 
(PUT 'FOREIGNENTRY 'OPERANDPRINTFUNCTION 'OPERANDPRINTFOREIGNENTRY)
 
(PUT 'FOREIGNENTRY 'ASMEXPRESSIONFUNCTION 'OPERANDPRINTFOREIGNENTRY)
 
(DE OPERANDPRINTCOMMENT (X)       % (COMMENT ...)
  (PROG NIL
        (PRINTCOMMENT (CADR X))))
 
(PUT 'COMMENT 'OPERANDPRINTFUNCTION 'OPERANDPRINTCOMMENT)
 
(DE MCPRINT (X)  % Echo of MC's
  (COND ((EQCAR X '*JUMPON) (CodePrintF "* Jumpon cmacro %n"))
        (T (CodePrintF "* %p%n" X))))
 
(DE INSTRUCTIONPRINT (X)
  (CodePrintF "* %p%n" X))
 
(PUT 'CERROR 'ASMPSEUDOOP 'PRINTCOMMENT)
 
% Use the flag to tell if we have two labels in a row.  If so, generate
%  the special syntax of label = * for the first label and continue
%  normally for the second.
 
(GLOBAL '(*LABELFOUND))
 
% Variable with the number of links in the code body.
 
(FLUID '(&LINKS-PRESENT&))
 
(DE ASMOUTLAP (U)
  (PROG (LOCALLABELS* OLDOUT)
        (SETQ &LINKS-PRESENT& % look-for-links is in CRlap
              (OR (look-for-links U) %%( ASSOC '*LAMBIND U)
                  (Assoc '*Id-Apply U)
          %%%%    (ASSOC '*PROGBIND U)
                  (ASSOC '*CALL U)))
        (SETQ U (PASS1LAP U))          % Expand cmacros, quoted expressions
        (CODEBLOCKHEADER)
        (SETQ OLDOUT (WRS CODEOUT*))
        (SETQ *LABELFOUND NIL)        % Reset to NIL in the beginning.
        (FOREACH X IN U DO (ASMOUTLAP1 X))
        (WRS OLDOUT)
        (CODEBLOCKTRAILER)))
 
 
%-- rrk 11/11/82 Modified this function because it is not putting out enough
%    spaces at the front of the line.  It has a variable,
%    InstructionLeadingSpaces* that must be set to the number of spaces to
%    print at the front of the line for each new instruction.
 
% Modify printlabel, so it will check the LabelFound flag and if already on
%  will print the special stuff on the end.
 
(DE CRAYPRINTLABEL (X)
  (COND (*LABELFOUND (PRINTF SPECIALLABELFORMAT* X X))
        (T (PROGN (SETQ *LABELFOUND T)
                  (PRINTF LABELFORMAT* X X)))))
 
 
(DE ASMOUTLAP1 (X)
  (PROG (FN)
        (RETURN (COND ((STRINGP X) (CRAYPRINTLABEL X))
                      ((ATOM X) (CRAYPRINTLABEL (FINDLOCALLABEL X)))
                      ((SETQ FN (GET (CAR X) 'ASMPSEUDOOP))
                       (PROGN (SETQ *LABELFOUND NIL)
                              (APPLY FN (LIST X))))
   % instruction output form is:
   % "space" <opcode>   "space" <operand> { "comma" <operand> }   "newlin
                      (T (PROGN (SETQ *LABELFOUND NIL)
                                (PRIN2 INSTRUCTIONLEADINGSPACES*)
                                                  % Whatever Leading.
                                (PRINTOPCODE (CAR X))
                                (SETQ X (CDR X))
                                (COND ((NOT (NULL X))
                                       (PROGN (PRIN2 '! ) % SPACE
                                              (PRINTOPERAND (CAR X))
                                              (FOREACH U IN (CDR X) DO
                                               (PROGN (PRIN2 '!,) %COMMA
                                                    (PRINTOPERAND U))))))
                                (PRIN2 (MKID 10)))))))) %NEWLINE
 
 
(DE CODEDECLAREEXPORTEDUSE (Y)
  (COND (*DECLAREBEFOREUSE (PROGN (CODEDECLAREEXPORTED Y)
                                   (CRAYPRINTLABEL Y)))
        (T (PROGN (CRAYPRINTLABEL Y)
                  (CODEDECLAREEXPORTED Y)))))
 
% we need another prin2 for tagged Integer value because CAL
% doesn't like them before 1.15
(COPYD 'OURPRIN2 'PRIN2)
 
(FLUID '(*TAGSHIFT))
(SETQ *TAGSHIFT 3000000)
 
(DE PRIN2(X)
   (COND 
     ((AND (NUMBERP X) (or (GREATERP X *TAGSHIFT)
                       (lessp X (minus *TAGSHIFT)))) (PANICPRINT X))
     (T (OURPRIN2 X))
)  )
 
(DE PANICPRINT(X)
  (PROG ()
   (cond ((eq x 0) (return (ourprin2 "O'"))))
   (PANICPRINT (lshift x -3))
   (ourprin2 (land x 7))
   (return nil)
) )
