%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Huge-frame.SL - alloc sequence for a huge frame ( greater 34)         %
%                                                                       %
% Author:      W. Neun , ZIB Berlin                                     %
%                                                                       %
% Date:       21 June 1986                                              %
%                                                                       %
% Copyright (c) 1987, Konrad Zuse Zentrum Berlin, all rights reserved   %
%                                                                       %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 
(fluid '(&Frame-Tregs& &Fast-Frame-Tregs&))
 
(DE FrameReg (Dum Number)
            (Cond ((Fast-Frame-Aux dum)
                      (List 'Reg (Indx &Fast-FRAME-TREGS& Number)))
                  ((lessp alloc-size* 34)
                               (List 'Reg (Indx &FRAME-TREGS& Number)))
                  (t (list 'indexed '(reg st) (minus number)))
)           )
 
 
(DefCMacro *Alloc              % Stack grows UP
         ((Fast-Frame))
         ((Freep))
         ((Zerop)
             (*Move (Reg st)  (Reg a0))    % Sets up address for save
             (blksto (Reg a3) (Reg PrevFrameSize)) % Save to memory
             (*wplus2 (Reg st) (Reg a3))   % Update stack pointer
             (*Move (Reg stkupbnd) (Reg a6)) % CHECK STACK ^
             (*wdifference3 (Reg a0) (Reg st) (Reg a6))
             (*Move (Reg b00) (Reg a6))    % Fetch Return addr to TReg
             (store (Reg a3) 0 (Reg st))   % First to Stack + 0
             (store (Reg a6) 1 (Reg st))   % First to Stack + 1
             (*wplus2 (Reg st) 2)          % Update stack pointer
             (*Move 0 (Reg a3))            % Set up current size
             (jap (plus2 (parcel SYMFNC) (times2 (idloc Stack-Blown-Up) 4))))
         ((FitsInStackP)
             (*Move (Reg st)  (Reg a0))    % Sets up address for save
             (blksto (Reg a3) (Reg PrevFrameSize)) % Save to memory
             (*wplus2 (Reg st) (Reg a3))   % Update stack pointer
             (*Move (Reg stkupbnd) (Reg a1)) % CHECK STACK !
             (*wdifference3 (Reg a0) (Reg st) (Reg a1))
             (*Move (Reg b00) (Reg a6))    % Fetch Return addr to TReg
             (*Move (Reg a6) (Reg s6))     % First to SReg
             (*Move (Reg a3) (Reg s7))     % Save old frame size
             (*Move (plus2 ArgOne 2) (Reg a3))  % Set up current size
             (jap (plus2 (parcel SYMFNC) (times2 (idloc Stack-Blown-Up) 4)))
             (*Move (Reg s6) (Reg ReturnAddr))  % Finally Store B00
             (*Move (Reg s7) (Reg PrevFrameSize)))% As previous
         (
             (*Move (Reg st)  (Reg a0))    % Sets up address for save
             (blksto (Reg a3) (Reg PrevFrameSize)) % Save to memory
             (*wplus2 (Reg st) (Reg a3))   % Update stack pointer
             (*Move (Reg stkupbnd) (Reg a6)) % CHECK STACK ^
             (*wdifference3 (Reg a0) (Reg st) (Reg a6))
             (*Move (Reg b00) (Reg a6))    % Fetch Return addr to TReg
             (store (Reg a3) 0 (Reg st))   % First to Stack + 0
             (store (Reg a6) 1 (Reg st))   % First to Stack + 1
             (*wplus2 (Reg st) (Plus2 ArgOne 2)) % Update stack pointer
             (*Move 0 (Reg a3))            % Set up current size
             (jap (plus2 (parcel SYMFNC) (times2 (idloc Stack-Blown-Up) 4))))
)
%---------------------------------------------------------------------
%   Deallocate argument elements off the stack
%   FORMAT: Number-of-locations
%  Warning: Number-of-locations must be a constant.
(DefCMacro *DeAlloc
         ((Fast-Frame-Aux))
         ((Freep))
         ((Zerop)
             (load (Reg a3) -2 (Reg st))
             (load (Reg a6) -1 (Reg st))
             (*Move 2 (Reg a7))
             (*wdifference (Reg st) (Reg a7))
             (*wdifference (Reg st) (Reg a3))    % Take the Stack down
             (*Move (Reg st) (Reg a0))           % Set up address
             (blklod (Reg a3) (Reg PrevFrameSize))% Do the load
             (*Move (Reg a6) (Reg b00))
             )
        ((FitsinStackP)
             (*Move (Reg PrevFrameSize) (Reg s7))% And Prev Frame ->a3
             (*Move (Reg s7) (Reg a3))           % Finally into a3
             (*wdifference (Reg st) (Reg a3))    % Take the Stack down
             (*Move (Reg ReturnAddr) (Reg s6))   % Move Retaddr to B00
             (*Move (Reg st) (Reg a0))           % Set up address
             (blklod (Reg a3) (Reg PrevFrameSize))% Do the load
             (*Move (Reg s6) (Reg a6))           % Finish Retaddr Move
             (*Move (Reg a6) (Reg B00)))
         (
             (*wdifference (Reg st) (plus2 Argone 2))
             (load (Reg a3) 0 (Reg st))
             (load (Reg a6) 1 (Reg st))
             (*wdifference (Reg st) (Reg a3))    % Take the Stack down
             (*Move (Reg st) (Reg a0))           % Set up address
             (blklod (Reg a3) (Reg PrevFrameSize))% Do the load
             (*Move (Reg a6) (Reg b00))
 )        )        % We are done
(De *PreDeAlloc(x)
   (cond ((Fast-Frame-Aux x) nil)
         ((Freep x) nil)
         ((Zerop x) nil)
         ((fitsinstackp x) '((*move (reg PrevFrameSize) (Reg S6))
                             (*move (reg ReturnAddr) (Reg S7))
                             (Store (Reg S6) 0 (Reg st))
                             (Store (Reg S7) 1 (Reg st))
                             (*Move 2 (Reg a7))
                             (*wplus2 (Reg st) (Reg a7))
                             (*Move 0 (Reg a3))))
         ( t `((*wdifference (reg st) (quote ,x))
               (*Move 0 (Reg a3))))
 ) )
 
(De *PostDeAlloc(x)
   (cond ((Fast-Frame-Aux x) nil)
         ((Freep x) nil)
         (t '((load (Reg a3) -2 (Reg st))
              (load (Reg a6) -1 (Reg st))
     %
     % on X-MP a (BLKlod for b00 and b01 could be better (b01-> a3)
     %
              (*Move 2 (Reg a7))
              (*wdifference (Reg st) (Reg a7))
              (*wdifference (Reg st) (Reg a3))    % Take the Stack down
              (*Move (Reg st) (Reg a0))           % Set up address
              (blklod (Reg a3) (Reg PrevFrameSize))% Do the load
              (*Move (Reg a6) (Reg b00))))
 ) )
