%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% File:         PC:TAGS.SL
% Description:  
% Author:       
% Created:      
% Modified:     25-Apr-84 08:49:24 (Brian Beach)
% Mode:         Lisp
% Package:      
% Status:       Experimental (Do Not Distribute)
%
% (c) Copyright 1983, Hewlett-Packard Company, all rights reserved.
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% Revisions:
%
% 20 Februar 1990 (Winfried Neun) exchanged pair-tag and vector-tag
% 14 December 1988 (Winfried Neun) changed code-tag to 20 in order to
%                  fit into 5 bit tag field.
%JAP: 19 Mar 1988 (Julian Padget)
%JAP:  Added tag declaration for stack group descriptors
%JAP: 17 Aug 1986 (Julian Padget)
%JAP:  Added tag declarations for bvectors, bstructs, contexts and funargs.
% 25 Jun 1986 (Leigh Stoller)
%  This file needs to be recompiled on the host machine when porting with the
%   tagbitlength set to target machine's value. It then must be loaded into
%   the cross compiler as the last module.
% 28 Mar 1984 1536-PST (Nancy Kendzierski)
%  Fixed file name in header.
% 19 Dec 1983 1759-PST (Nancy Kendzierski)
%  Added header.
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

(CompileTime 

 (de DeclareTagRange (NameList StartingValue Increment) 
   (let ((result '(PROGN)))
     (while NameList 
       (setq Result (cons `(define-constant ,(first namelist) ,startingvalue)
			  Result)) 
       (setq StartingValue (plus StartingValue Increment)) 
       (setq NameList (rest NameList)))
     (reverse result)
     ))

 (dm LowTags (U) 
   (DeclareTagRange (cdr U) 0 1)) 

 (dm HighTags (U) 
   (DeclareTagRange (cdr U) 
		    (difference (LSH 1 (compiler-constant 'TagBitLength)) 1)
		    -1))
 )


%
% JumpInType and friends depend on the ordering and contiguity of
% the numeric type tags.  Fast arithmetic depends on PosInt = 0,
% NegInt = -1.  Garbage collectors depend on pointer tags being
% between PosInt and Code, non-inclusive. /csp
%

(lowtags posint-tag
         bstruct-tag
         forward-tag
	 bignum-tag
	 oddint-tag
         oio-tag
         pair-tag
         sdo-tag)

(define-constant string-tag 7)
(define-constant bytes-tag 7)
(define-constant halfwords-tag 7)
(define-constant words-tag   7)
(define-constant vector-tag  7)
(define-constant evector-tag 7)
(define-constant bvector-tag 7)
(define-constant context-tag 7)
(define-constant funarg-tag 7)
(define-constant sgd-tag 7)
(define-constant code-tag 7)
(define-constant floatnum-tag 7)

(define-constant id-tag 16#d)
(define-constant unbound-tag 16#15)
(define-constant btr-tag 16#1d)

(define-constant hbignum-tag    16#17)
(define-constant hfloat-tag     16#1f)
(define-constant hbytes-tag     16#27)
(define-constant hstring-tag    16#2f)
(define-constant hhalfwords-tag 16#37)
(define-constant hwords-tag   16#3f)
(define-constant hcode-tag    16#47)
(define-constant hdesagg-tag  16#4f)
(define-constant hvect-tag    16#57)
(define-constant hevect-tag   16#5f)
(define-constant hbvect-tag   16#67)
(define-constant hfunarg-tag  16#6f)
(define-constant hcontext-tag 16#77)
(define-constant hsgd-tag     16#7f)


