%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% File:         PXNK:TIMC.SL
% Description:  Get run time in milliseconds.                              
% Author:       Leigh Stoller
% Created:      22-Dec-86
% Package:      
% RCS $Header: $
%
% (c) Copyright 1986, University of Utah.
% (c) Copyright 1984, Hewlett-Packard Company, all rights reserved.        
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Revisions:
%
% 12-Jun-87 (Leigh Stoller)
%  Changed call from wdifference to difference, since wdifference does
%   not work on fixnums. Moved initialization of *start-time* to a loadtime
%   form.
% 13-Mar-87 (Leigh Stoller)
%  Under SYS V Unix, the process time is reported as the number of
%   milliseconds since the the machine was rebooted. This gets to be very
%   large number potentially. Compiled code cannot deal with these fixnums
%   if the opencode was for inums. So, store the beginning time in *start-time*
%   and return the difference between (timc) and *start-time*,
% 22-Dec-86 (Leigh Stoller)
%  Copied from vax nonkernel directory.
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

(fluid '(*start-time*))

(compiletime (load sys-macros))
(on fast-integers)

(declare-warray timebuffer size 4)

% Get run-time in milliseconds. Left in for compatability
(de time ()
  (difference (sys2int (timc)) *start-time*))

% Returns time in 1/1020'ths of a second.
% Change the 17 to a 20 in Europe for 50hz operation.

(de timc ()
  (external_timc timebuffer)
  (wtimes2 (getmem timebuffer) 17))

(loadtime (setf *start-time* (sys2int (timc))))

(off fast-integers)
