/*-------------------------------------------------------------------------*/
/*
 * File:         PXU:c2lTest.c
 * Description:  Routines to test lisp<->C interface.
 * Author:       Harold Carr
 * Created:      February 1987
 * Package:
 * RCS $Header: $
 *
 * (c) Copyright 1987, University of Utah, all rights reserved
 */
/*-------------------------------------------------------------------------*/

int    foreign_data_word  = 0xabc;
double foreign_data_float = 6789.1234;

int show_globals() {
  printf("C   : %x\n", foreign_data_word);
  printf("C   : %f\n", foreign_data_float);
  return(1);
}

int bits(b)
int b;
{
  int v = b;
  printf("C   : %x\n", v);
  return(v);
}

int booleans(b)
int b;
{
  int v = b;
  if (b) printf("C   : True\n", v);
  else   printf("C   : False\n", v);
  return(v);
}

char chars(c)
char c;
{
  char v = c;
  printf("C   : %c\n", v);
  return(v);
}

double *c_float_ptr()
{
  static double v = 45.0102;
  return(&v);
}

double *float_ptrs(f)
double *f;
{
  double *v = f;
  printf("C   : %f\n", *v); 
  *v=99.34;
  return(v); 
}

double *test_float2(one, two)
double *one, *two;
{
  printf("C   : one = %f, two = %f\n", *one, *two); 
}

double *floats(f)
double f;
{
  static double v;

  v = f;
  printf("C   : %f\n", v);
  return(&v);
}

int ints(i)
int i;
{
  int v = i;
  printf("C   : %d\n", v);
  return(v);
}

char *strings(s)
char *s;
{
  char *v = s;
  printf("C   : %s\n", v);
  return(v);
}

int vc(id)
int id;
{
    int v = lisp_value_cell(id);   /* Get the value via C. */
    printf("C   : %x\n", v);
    return(v);
}

int svc(id, value)
int id, value;
{
    int v = set_lisp_value_cell(id, value);
    printf("C   : %x\n", v);
    return(v);
}

/* End of file. */
