%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% File:         PXU:c2ltest.sl
% Description:  Test file for testing lisp<->C interface.
% Author:       Harold Carr
% Created:      Summer 1985
% Package:      
% RCS $Header: $
%
% (c) Copyright 1987, University of Utah, all rights reserved
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

(bothtimes
 (load useful)    % For LET.
)

%(compiletime
% (load l2cdatacon)
%)

(flag 
 '(
   _bits
   _booleans
   _chars
   _c_float_ptr
   _float_ptrs
   _floats
   _ints
   _strings
   _show_globals
   _vc
   _svc
   _run_lisp_func
   _call_lisp0
   _call_lisp1
  )
 'foreignfunction
)

(fluid '(*a*))

(de vc (id)
  (bits-from-c (_vc (id-to-c id))))

(de svc (id value)
  (bits-from-c (_svc (id-to-c id) (bits-to-c value))))

(de test-interface-message (arg)
  (printf " It works.  Arg: %p%n" arg)
  (printf " Provide a return value: ")
  (read))

(de test-interface (test-function-address test-function-id arg)
  (let ((outputbase* 16) (promptstring* nil) (v))
    (printf "%nBITS:%n")
    (printf "To  : %p%n" (setf v 16#7fffffff))
    (printf "From: %p%n" (bits-from-c (_bits (bits-to-c v))))
    (printf "To  : %p%n" (setf v 35.7401))
    (printf "From: %p%n" (bits-from-c (_bits (bits-to-c v))))
    (printf "To  : %p%n" (setf v 'an-id))
    (printf "From: %p%n" (bits-from-c (_bits (bits-to-c v))))
    (printf "To  : %p%n" (setf v '(a . pair)))
    (printf "From: %p%n" (bits-from-c (_bits (bits-to-c v))))
    (printf "To  : %p%n" (setf v [a vector]))
    (printf "From: %p%n" (bits-from-c (_bits (bits-to-c v))))
    (printf "To  : %p%n" (setf v "a string"))
    (printf "From: %p%n" (bits-from-c (_bits (bits-to-c v))))
    (printf "To  : %p%n" (setf v (cdr (getd 'cdr))))
    (printf "From: %p%n" (bits-from-c (_bits (bits-to-c v))))

    (printf "%nBOOLEAN:%n")
    (printf "To  : %p%n" (setf v t))
    (printf "From: %p%n" (boolean-from-c (_booleans (boolean-to-c v))))
    (printf "To  : %p%n" (setf v nil))
    (printf "From: %p%n" (boolean-from-c (_booleans (boolean-to-c v))))

    (printf "%nCHAR:%n")
    (printf "To  : %p%n" (setf v #/A))
    (printf "From: %p%n" (char-from-c (_chars (char-to-c v))))
    (printf "To  : %p%n" (setf v #/b))
    (printf "From: %p%n" (char-from-c (_chars (char-to-c v))))

    (printf "%nC-PTR:%n")
    (printf "From: %p%n" (setf v (c-ptr-from-c (_c_float_ptr))))
    (printf "To  : %p%n" (c-ptr-from-c (_float_ptrs (c-ptr-to-c v))))
    (printf "From: %p%n" (setf v (c-ptr-from-c (_strings (string-to-c "st")))))
    (printf "To  : %p%n" (c-ptr-from-c (_strings (c-ptr-to-c v))))
    
    (printf "%nFLOAT:%n")
    (printf "To  : %p%n" (setf v 123.456))
    (printf "From: %p%n" (float-from-c(_floats(float1-to-c v)(float2-to-c v))))
    (printf "To  : %p%n" (setf v 123.456))
    (printf "From: %p%n" (float-from-c (_float_ptrs (float-to-c v))))

    (printf "%nID:%n")
    (printf "To  : %p%n" (setf v 'id))
    (printf "From: %p%n" (id-from-c (_bits (id-to-c v))))

    (printf "%nID TO STRING:%n")
    (printf "To  : %p%n" (setf v 'id))
    (printf "From: %p%n" (string-from-c (_strings (id-to-string-to-c v))))

    (printf "%nINT:%n")
    (let ((outputbase* 10))  %psl bug - bus errors trying to print -357
	                     %in base 16.
    (printf "To  : %p%n" (setf v -357))
    (printf "From: %p%n" (int-from-c (_ints (int-to-c v))))
    )

    (printf "%nSTRING:%n")
    (printf "To  : %p%n" (setf v "a string"))
    (printf "From: %p%n" (string-from-c (_strings (string-to-c v))))

    (printf "%nSTRING TO ID TO C:%n")
    (printf "To  : %p%n" (setf v "a string"))
    (printf "From: %p%n" (id-from-c (_bits (string-to-id-to-c v))))

    (printf "%nSTRING TO ID FROM C:%n")
    (printf "To  : %p%n" (setf v "a string"))
    (printf "From: %p%n" (string-to-id-from-c (_strings (string-to-c v))))

    (printf "%nVOID:%n")
    (printf "To  : %p%n" (setf v "a string"))
    (printf "From: %p%n" (void-from-c (_strings (string-to-c v))))

    (printf "%nFOREIGN WORD:%n")
    (printf "From: %p%n" (foreign-data-word '_foreign_data_word))
    (printf "To  : %p%n" (setf v 16#123))
    (printf "From: %p%n" (set-foreign-data-word '_foreign_data_word(int-to-c v)))
    (printf "From: %p%n" (boolean-from-c (_show_globals)))

    (printf "%nFOREIGN FLOAT:%n")
    (printf "From: %p%n" (foreign-data-float '_foreign_data_float))
    (printf "To  : %p%n" (setf v 45.01209))
    (printf "From: %p%n" (set-foreign-data-float '_foreign_data_float v))
    (printf "From: %p%n" (boolean-from-c (_show_globals)))

    (printf "%nValue cell access:%n")
    (printf "To  : %p%n" (setf *a* 0))           %These are inums.
    (printf "From: %p%n" (vc '*a*))              %C will print the same value.
    (printf "To  : %p%n" (setf *a* 16#07ffffff))
    (printf "From: %p%n" (vc '*a*))
    (printf "To  : %p%n" (setf *a* 16#0fffffff)) %These are integers.
    (printf "From: %p (pointer)%n" (vc '*a*))    %C will print the pointer.
    (printf "To  : %p%n" (setf *a* 16#7fffffff)) %These are integers.
    (printf "From: %p (pointer)%n" (vc '*a*))    %C will print the pointer.

    (printf "%nValue cell setting:%n")
    (printf "To  : %p%n" (setf v 0))
    (printf "From: %p%n" (svc '*a* v))
    (printf "Vc  : %p%n" *a*)
    (printf "To  : %p%n" (setf v '(1 2)))
    (printf "From: %p%n" (svc '*a* v))
    (printf "Vc  : %p%n" *a*)
    (printf "To  : %p%n" (setf v [45.01]))
    (printf "From: %p (pointer)%n" (svc '*a* v))
    (printf "Vc  : %p%n" *a*)
    (printf "To  : %p%n" (setf v 16#7fffffff))
    (printf "From: %p (pointer)%n" (svc '*a* v))
    (printf "Vc  : %p%n" *a*)

    (printf "%nFunction cell by address:%n")
    (printf "To  : %p%n" (setf v test-function-address))
    (printf "From: %p%n" (bits-from-c (_run_lisp_func (bits-to-c v))))

    (printf "%nFunction cell by id:%n")
    (printf "To  : %p%n" (setf v test-function-id))
    (printf "From: %p%n" (bits-from-c (_call_lisp0 (id-to-c v))))

    (printf "%nArgument passing:%n")
    (printf "To  : %p %p%n" (setf *a* test-function-id) (setf v arg))
    (printf "From: %p%n" (bits-from-c (_call_lisp1 (id-to-c *a*)(bits-to-c v))))

    (printf "%nTest complete.%n")))

(loadtime (progn
 (printf "Use the following code address for test: %p%n"
         (getd 'test-interface-message))
 (printf
  "Do: (test-interface 16#<address> 'test-interface-message 16#123)%n")
))

% End of file.
