%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% File:         PU:INIT-FILE.SL 
% Description:  Function which reads an init file 
% Author:       Eric Benson 
% Created:      21 September 1982 
% Modified:     26 Jan 1984 1550-PST (Brian Beach) 
% Mode:         Lisp 
% Package:      
% Status:       Experimental (Do Not Distribute) 
% Compiletime:  PL:IF-SYSTEM.B 
% Runtime:      
%
% (c) Copyright 1983, Hewlett-Packard Company, all rights reserved.
% Copyright (c) 1982 University of Utah
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% Revisions:
%
% 26 Jan 1984 1550-PST (Brian Beach)
%  Corrected file name in header.
% 11 Jan 1984 1954-PST (Nancy Kendzierski)
%  Added header and contents of .BUILD file.
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

(compiletime (load if-system))

(if_system Tops20 (imports '(homedir)))

(de read-init-file (program-name)
  % Don't read init files during Unix config scripts.
  (cond ((if_system Unix (null (getenv "SavingPSL")) T)
	 ((lambda (f)
	    (cond ((filep f) (lapin f))))
	  (init-file-string program-name)))))

(de init-file-string (program-name)
  % Build init file name.
  (bldmsg "%w/.%wrc" (getenv "HOME") program-name))


