CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C File : USHELL - UNICOS system interface routines for PSL3.4
C
C Author : W. Neun ,ZIB Berlin
C          Based on PSL32 version by Dana J. Dawson, Cray Research Inc.
C
C Date : 20-May-86
C
C (c) Copyright 1987 Konrad Zuse Zentrum, Berlin, all rights reserved
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
 
      SUBROUTINE GETHMCC (IX)
      INTEGER IFELD(128)
      INTEGER MEMO (128)
      POINTER(IX,MEMO)
      CALL GETHMC(IFELD)
      DO 100 I=1,128
100   MEMO(I)=IFELD(I)
      RETURN
      END
 
C     SUBROUTINE COSINIT (X)
C
C  For now, only initializes the timer.  May also
C  have to print a welcome message, open & ASSIGN
C  files, etc.
C
C     COMMON /TIMCOM/ ICPTIM
C
C  Welcome
C
C     WRITE(101,10)
C  10 FORMAT(///' ',' --- CRAY/COS PSL 3.4 ---'///)
C
C  Initialize timer (in milliseconds).
C  'CPUTIM' is a renamed copy of the COS UTLIB routine 'SECOND'.
C
C     CALL CPUTIM (RCPTIM)
C     ICPTIM = INT (RCPTIM * 1000.0)
C
C     RETURN
C     END
C
C ----------------------------------------------------------------------
C
      SUBROUTINE COSPUTC (ICHAR)
C
C  Performs buffered character output to $OUT
C
      IMPLICIT INTEGER(A-Z)
      COMMON /IOSTUF/ BRK,ERR, FILEDN(32), FILEPDN(2,32), INUSE(32)
     *               , IDF(2) , DEFO(3)
      COMMON /PUTCOM/ LINE(132), IPOS
      DATA IPOS /0/
C
      BRK = 17
      IF (ICHAR .EQ. 10) THEN
         WRITE (101,10) (LINE(I),I=1,IPOS)
   10    FORMAT(' ',132R1)
         IPOS = 0
         GOTO 54321
      ENDIF
C
      IF (ICHAR .EQ.26) THEN
         IPOS = 0
         GOTO 54321
      ENDIF
C
      IPOS = IPOS + 1
      LINE(IPOS) = ICHAR
      IF (IPOS .GE. 132) THEN
         WRITE (101,10) LINE
         IPOS = 0
         GOTO 54321
      ENDIF
C
54321 IF (BRK.LT.0) CALL LISPRPV
      BRK = 0
      RETURN
      END
C
C ----------------------------------------------------------------------
C
      SUBROUTINE COSGETC (ICHAR)
C
C  Performs buffered character input from $IN
C
      IMPLICIT INTEGER(A-Z)
      COMMON /GETCOM/ LINE(133), IPOS, NCHARS
      COMMON /IOSTUF/ BRK,ERR, FILEDN(32), FILEPDN(2,32), INUSE(32)
     *               , IDF(2) , DEFO(3)
C
      BRK = 17
      DATA IPOS, NCHARS /1, 0/
C
      IF (IPOS .GE. NCHARS) THEN
C         WRITE (101,10)
C   10    FORMAT(' ','>>')
         NCHARS = 132
         CALL READC (100, LINE, NCHARS, ISTAT)
         IF (ISTAT .GE. 3) GO TO 20
         IPOS = 0
         IF (ISTAT .EQ. 2  .AND.  NCHARS .EQ. 0) THEN
            ICHAR = 26
            GOTO 54321
         ENDIF
         NCHARS = NCHARS + 1
         LINE(NCHARS) = 10
      ENDIF
C
      IPOS = IPOS + 1
      ICHAR = LINE(IPOS)
      GOTO 54321
C
   20 CONTINUE
      WRITE (101,30)
   30 FORMAT(' ','ERROR in COSGETC')
      ICHAR = 26
C
54321 IF (BRK.LT.0) CALL LISPRPV
      BRK = 0
      RETURN
      END
C
C ----------------------------------------------------------------------
 
      SUBROUTINE UNICOSQ (IP)
C
C  Terminates execution.  Also CLOSES and SAVES open files.
C  Added also statistics
C
      POINTER (IP,MEMO)
      DIMENSION MEMO (10)
      COMMON /IOSTUF/ BRK, ERR, FILEDN(32), FILEPDN(2,32), INUSE(32)
     *               , IDF(2) , DEFO(3)

C
C     CALL COSPUTC (13)
C     CALL COSPUTC (10)
C     CALL COSPUTC (26)
C
      DO 10 I=1,32
C
        IF (INUSE(I).GT.9) CALL COSWCLS(I)
C
   10 CONTINUE
 
      CALL NORPV
C do not catch aborts anymore
C
      WRITE(101,'(A)') ' '
      WRITE(101,'(A)')
     1  ' ........................................................'
      WRITE(101,'(A,A8,A,A8,A)')
     1 ' .    PSL 3.4            ',MEMO(10),'    ',MEMO(9),
     1 '           .'
      WRITE(101,'(A,I10,A,I9,A)')
     1  ' . Total cpu time:',MEMO(2),' ms      heapsize:',MEMO(5),' .'
      WRITE(101,'(A,I5,A,I9,A)') ' . Garbage collections:'
     1           ,MEMO(3),'          bpssize:',MEMO(6),' .'
      WRITE(101,'(A,I10,A,I8,A)')
     1' . Time for gc:   ',MEMO(4),' ms     stacksize: ',MEMO(7),' .'
      WRITE(101,'(A,I8,A,I8,A)')
     1            ' . Ratio: gc / total',(100*MEMO(4))/(MEMO(2) +1)
     1                           ,'  %    bndstksize: ',MEMO(8),' .'
      WRITE(101,'(A)')
     1  ' ........................................................'
 
      CLOSE(101,ERR=12376)
12376 CONTINUE
      IF(MEMO(1).LT.0) THEN
           CALL REMARK('****** Abort in PSL 3.4 *********'L)
           CALL ABORT ('*********************************'L)
      ELSE
           CALL FINALE
      ENDIF
      END
C
C ----------------------------------------------------------------------
C
      SUBROUTINE COSDATE (IPDATE)
C
C  Returns the current date in ASCII (mm/dd/yy)
C  'MMDDYY' is a renamed copy of the COS UTLIB routine 'DATE'.
C
      INTEGER  DATE
      POINTER (IPDATE, IDATE)
C
      IDATE = DATE()
C
      RETURN
      END
C
C ----------------------------------------------------------------------
C
      SUBROUTINE COSTIMR (IPTIME)
C
C  Returns the current time in ASCII (hh:mm:ss)
C
      POINTER (IPTIME, ITIME)
      ITIME = CLOCK()
C
      RETURN
      END
C
C ----------------------------------------------------------------------
C
      SUBROUTINE COSERR (X)
C
C  Error termination
C
      WRITE (101,10)
   10 FORMAT(' ','COSERR called')
      CALL COSQUIT (0)
C
      RETURN
      END
C
C ----------------------------------------------------------------------
C
      SUBROUTINE COSPUTO (NUM)
C
C  Print NUM as in octal
C
      CHARACTER * 24 OCTO
      WRITE(OCTO,'(A,O22)') '8#',NUM
      DO 10 I = 1,24
      CALL COSPUTC ( ICHAR ( OCTO(I:I) ) )
   10 CONTINUE
C
      NUM=0
      RETURN
      END
C
C ----------------------------------------------------------------------
C
      SUBROUTINE COSPUTI (NUM)
C
C  Print NUM as an integer
C
      IF (NUM.LT.0) THEN
          NUM=-NUM
          CALL COSPUTC (45)
C - sign
      ENDIF
 
      ITEMP = NUM
      NDIG = 0
      IF (NUM .GT. 0) NDIG = INT(ALOG10(FLOAT(NUM)+0.5))
C
 
      DO 10 IEXP = NDIG, 0, -1
      IDIGIT = ITEMP / (10**IEXP)
      ITEMP = ITEMP - (IDIGIT * (10**IEXP))
      CALL COSPUTC (IDIGIT + 48)
   10 CONTINUE
C
      NUM=0
      RETURN
      END
C
C ----------------------------------------------------------------------
C
      SUBROUTINE COSFWRIT (IPS1, IPR2, IPFMT)
C
      COMMON /IOSTUF/ BRK,ERR, FILEDN(32), FILEPDN(2,32), INUSE(32)
     *               , IDF(2) , DEFO(3)
      POINTER (IPS1, ISTRNG), (IPR2, R2), (IPFMT,FMT)
      INTEGER BRK
      DIMENSION ISTRNG(5)
      DIMENSION FMT(5)
      CHARACTER*32 TEMP,TEMP1
      CHARACTER*1  CHAR1
 
C let an error occur before I/O is involved
 
        IF(ISTRNG(1).EQ.R2) I=0
        IF(FMT(1).EQ.17) I=1
        BRK = 17
        WRITE(TEMP1,'(4A8)',ERR=991) FMT(2),FMT(3),FMT(4),FMT(5)
 
C  WRITE R2 into TEMP in TEMP1 - format.
 
        WRITE (TEMP,TEMP1,ERR=991) R2
 
C  Find first & last non-blank characters and the length.
 
      DO 10 I=1,31
        IF (TEMP(I:I) .NE. ' ') GO TO 20
   10 CONTINUE
C
C
   20 CONTINUE
C
      DO 30 J=I,31
        IF (TEMP(J:J) .EQ. ' ') GO TO 40
   30 CONTINUE
      J=31
      GO TO 40
C
991   J=11
      DO 992 I=1,31
      TEMP(I:I)='*'
992   CONTINUE
      I=1
C
C
   40 CONTINUE
C
      LENGTH = J - I
C
C  Left justify & blank fill the string.
C
      DO 50 K=1,LENGTH
        CHAR1 = TEMP(I:I)
        TEMP(K:K) = CHAR1
        I = I + 1
   50 CONTINUE
C
      DO 60 L=K,31
        TEMP(L:L) = ' '
   60 CONTINUE
C
C  Now set the first word of ISTRNG to the
C  zero-based length of the string, and
C  read the string into words 2 and 3 of ISTRNG.
C
      ISTRNG(1) = LENGTH - 1
C
      READ(TEMP,'(4A8)') ISTRNG(2), ISTRNG(3), ISTRNG(4), ISTRNG(5)
C
      IF(BRK .LT. 0) CALL LISPRPV
      BRK = 0
      RETURN
      END
C ----------------------------------------------------------------------
C
C Set continue at interrupt: sets condition for interrupt routine to
C continue the operation (if i .ne. 0) Subroutine always returns the
C old value, which is .lt.0 when an interrupt occured; so the caller
C should call (lisprpv) if this happens
C
      SUBROUTINE COSSCA (I)
C
      COMMON /IOSTUF/ BRK,ERR, FILEDN(32), FILEPDN(2,32), INUSE(32)
     *               , IDF(2) , DEFO(3)
      INTEGER BRK
      J=BRK
      BRK=I
      I=J
      END

